﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PropertyGrid.Controls
{
    /// <summary>
    /// This class is a static class with many useful functions in order to manipulate dates and times.
    /// </summary>
    public class DateTimeHelpers
    {
        /// <summary>
        /// This method computes the first day of the month.
        /// </summary>
        /// <param name="pDateTime">The date time as reference</param>
        /// <returns>The first day of the week.</returns>
        static public DayOfWeek GetFirstDayOfMonth(DateTime pDateTime)
        {
            Int32 lReminder = (pDateTime.Day % 7 ) - 1;
            Int32 lCurrentDayWeekAsInt = (Int32)pDateTime.DayOfWeek + 7;
            Int32 lDiff = lCurrentDayWeekAsInt - lReminder;

            return (DayOfWeek)(lDiff % 7);
        }

        /// <summary>
        /// This method computes the first day of the year.
        /// </summary>
        /// <param name="pDateTime">The date time as reference</param>
        /// <returns>The first day of the week.</returns>
        static public DayOfWeek GetFirstDayOfYear(DateTime pDateTime)
        {
            Int32 lReminder = (pDateTime.DayOfYear % 7) - 1;
            DayOfWeek lFirstDay = (pDateTime.DayOfWeek + 7) - lReminder;

            return lFirstDay;
        }
    }
}
