﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using PropertyGridLib;
using PropertyGridEditors.ViewModels;

namespace PropertyGridSample
{
    /// <summary>
    /// Logique d'interaction pour Window1.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            PropertyViewModelFactory.Instance.AddViewModelForType(typeof(BooleanPropertyViewModel), typeof(System.Boolean));
            PropertyViewModelFactory.Instance.AddViewModelForType(typeof(ColorPropertyViewModel), typeof(System.Windows.Media.Color));
            PropertyViewModelFactory.Instance.AddViewModelForType(typeof(DateTimePropertyViewModel), typeof(System.DateTime));
            PropertyViewModelFactory.Instance.AddViewModelForType(typeof(NumericPropertyViewModel), typeof(System.Int32));
            PropertyViewModelFactory.Instance.AddViewModelForType(typeof(NumericPropertyViewModel), typeof(System.Double));
            PropertyViewModelFactory.Instance.AddViewModelForType(typeof(NumericPropertyViewModel), typeof(System.Single));
            PropertyViewModelFactory.Instance.AddTemplate(typeof(BooleanPropertyViewModel), "CheckBoxTemplate");
            PropertyViewModelFactory.Instance.AddTemplate(typeof(ColorPropertyViewModel), "ColorPickerTemplate");
            PropertyViewModelFactory.Instance.AddTemplate(typeof(DateTimePropertyViewModel), "DateTimePickerTemplate");
            PropertyViewModelFactory.Instance.AddTemplate(typeof(NumericPropertyViewModel), "NumericEditorTemplate");
            
            MyExampleObjetWithoutAttribute lObject = new MyExampleObjetWithoutAttribute();

            mPropertyEditor.SelectedObject = lObject;
            mPropertyTester.Instance = lObject;

            lObject.DoubleValue = 77.0;
            lObject.IntValue = 56789;
            lObject.FloatValue = -15.1f;
            lObject.StrValue = "Nicolas";
            lObject.BoolValue = true;
            lObject.ColorValue = Colors.Yellow;
        }
    }
}
